#include "CShiori.h"


CShiori::CShiori( string strSenderName )
{
	this->wstrSenderName = sjis_to_utf16( strSenderName.c_str() );
	this->bErr		=	false;
	this->bExist	=	false;
	this->hModule	=	NULL;
	this->wstrCharCode	=	L"Shift_JIS";
	this->fprequest	=	NULL;
	this->fpload	=	NULL;
	this->fpunload	=	NULL;

}

bool CShiori::load( const char *filename, string strDirPath )
{
	if( this->bErr )	return false;

	// dirpassNULL͎̎ŃtH_[̃pX擾
	if( strDirPath == "" )
	{
		char	strBuf[MAX_PATH+1];
		GetCurrentDirectory( MAX_PATH + 1 , strBuf );
		strDirPath	=	strBuf;
		strDirPath	+=	"\\";
	}

	// dll̃pX
	this->strFilePath	=	strDirPath;
	this->strFilePath	+=	filename;

	// dllǂݍ
	this->hModule	=	LoadLibrary( this->strFilePath.c_str() );
	if( this->hModule == NULL )
	{
		this->bErr	=	true;
		return false;
	}

	// dll̕KvȊ֐ǂݍ
	this->fpload	=	(_loadfp)GetProcAddress( this->hModule, "load" );
	this->fprequest	=	(_requestfp)GetProcAddress( this->hModule, "request" );
	this->fpunload	=	(_unloadfp)GetProcAddress( this->hModule, "unload" );
	if( !this->fpload || !this->fprequest || !this->fpunload )
	{
		this->bErr	=	true;
		return false;
	}

	// dllload֐ĂԁBload֐̈ŃfBNg̃pX
	// fBNgpX̒+1TCỸm
	HGLOBAL	hg	=	GlobalAlloc( GMEM_FIXED, strDirPath.length()+1 );
	memcpy( hg, strDirPath.c_str(), strDirPath.length()+1 );
	long	len	=	(long)strDirPath.length();// lenɓ
	this->fpload( hg, len );// shioriload֐Ăяo

	this->bExist	=	true;

	return true;
}


wstring CShiori::request( const wchar_t *ps )
{
	if( this->bErr )	return wstring(L"err");

	string	strRequest;
	if( this->wstrCharCode == L"UTF-8" )
	{
		strRequest	=	utf16_to_utf8( ps );
	}
	else
	{
		strRequest	=	utf16_to_sjis( ps );
	}

	HGLOBAL	hg	=	GlobalAlloc( GMEM_FIXED, strRequest.length() );
	memcpy( hg, strRequest.c_str(), strRequest.length() );
	long	*len	=	(long*)GlobalAlloc( GMEM_FIXED, sizeof(long) );
	*len	=	(long)strRequest.length();// lenɓ 
	hg	=	this->fprequest( hg, len );// shioriload֐Ăяo

	// request̕Ԓl͂map_requestɓ
	map< string, string >	map_request;
	// hg̓eƗ̈wpɃRs[iI[\0tĕƂĈ̂Łj
	char *wp	=	new char[*len+1];
	memcpy( wp, hg, *len );
	wp[*len]	=	'\0';
	GlobalFree( hg );
	GlobalFree( len );

	this->RequestAnalyze( string(wp), map_request);// 肩̕ԓ^ɐē
	delete	wp;

	// R[h𒲂ׂ
	if( map_request.find("Charset")->second.find("UTF-8") != string::npos )
		this->wstrCharCode	=	L"UTF-8";
	else
		this->wstrCharCode	=	L"Shift_JIS";

	if( map_request.find( "head" ) != map_request.end() )
	{
		string str_head = map_request.find( "head" )->second;

		// ɕԂ镶񂪂ȂȂ"No Content"ԂB
		if( str_head.find("204 No Content") != string::npos )
			return wstring(L"204 No Content");

		if( str_head.find("400 Bad Request") != string::npos )
			return wstring(L"400 Bad Request");

	}

	// G[łȂNo ContentłȂiValue͂ĵValue"No Content"ԂB
	if( map_request.find( "Value" ) == map_request.end() )
		return wstring(L"No Content");

	// Shift_JISUTF-8ꂼʂē̕R[hɕϊB
	if(	map_request.find("Charset") != map_request.end() )
	{
		if( map_request.find("Charset")->second.find("UTF-8") != string::npos )
		{
			// R[hUTF-8̂Ƃ
			return utf8_to_utf16( map_request.find("Value")->second.c_str() );
		}
		else
		{
			// R[hShift_JIŜƂ
			return sjis_to_utf16( map_request.find("Value")->second.c_str() );
		}
	}
	else
		return wstring( L"err" );
}

wstring CShiori::request( bool getflg, const char *strID, int refnum, ... )
{
	wstring	req;
	req	+=	getflg ? L"GET" : L"NOTIFY";
	req	+=	L" SHIORI/3.0\r\nCharset: ";
	req	+=	this->wstrCharCode;
	req	+=	L"\r\nSecurityLevel: local\r\n";
	req	+=	L"ID: ";
	req	+=	sjis_to_utf16( strID );

	va_list	list;
	va_start( list, refnum );

	for( int i=0; i < refnum; i++ )
	{
		req	+=	L"\r\nReference";
		wchar_t	buf[64];
		_itow( i, buf, 10 );
		req	+=	buf;
		req	+=	L": ";
		req	+=	va_arg(list, wchar_t*);
	}

	va_end( list );

	req	+=	L"\r\nSender: ";
	req	+=	this->wstrSenderName;
	req	+=	L"\r\n\r\n";

	return this->request( req.c_str() );
}

wstring CShiori::request( bool getflg, const char *strID, vector<wstring> &vecRef )
{
	wstring	req;
	req	+=	getflg ? L"GET" : L"NOTIFY";
	req	+=	L" SHIORI/3.0\r\nCharset: ";
	req	+=	this->wstrCharCode;
	req	+=	L"\r\nSecurityLevel: local\r\n";
	req	+=	L"ID: ";
	req	+=	sjis_to_utf16( strID );

	for( int i=0; i < vecRef.size(); i++ )
	{
		req	+=	L"\r\nReference";
		wchar_t	buf[64];
		_itow( i, buf, 10 );
		req	+=	buf;
		req	+=	L": ";
		req	+=	vecRef[i];
	}

	req	+=	L"\r\nSender: ";
	req	+=	this->wstrSenderName;
	req	+=	L"\r\n\r\n";

	return this->request( req.c_str() );
}

/*
	SSTPvgRɏ]͂B
	܂擪"\r\n"܂ł"head"ƂL[Ŋi[āA
	̌͐擪":"̑O܂ł̕L[ɁA": "ォ"\r\n"܂łlɂĊi[B
*/
bool CShiori::RequestAnalyze( string& strRequest, map< string, string >& mapRequest )
{
	size_t	S = 0,
			E = 0,
			M = 0;

	E	=	strRequest.find( "\r\n" );
	mapRequest.insert( pair<string,string>( "head", strRequest.substr( 0, E ) ) );

	S	=	E+2;// \r\ňֈړ
	do
	{
		M	=	strRequest.find( ": ", S );// L[ƒl̋؂ɂȂ":"T
		E	=	strRequest.find( "\r\n", M+2 );// M̌\r\n̈ʒuT

		// MÊǂ炩łȂG[
		if( M == strRequest.npos || E == strRequest.npos )
			return false;

		mapRequest.insert( pair<string,string>(strRequest.substr( S, M-S ), strRequest.substr( M+2, E-(M+2) )) );

		S	=	E+2;// \r\ňֈړ
	}
	while( strRequest.length()-S > 2 );// cQȉɂȂ甲

	return true;
}



bool CShiori::unload()
{
	if( this->hModule )	this->fpunload();
	if( this->hModule ) FreeLibrary( this->hModule );

	this->bErr		=	false;
	this->bExist	=	false;
	this->hModule	=	NULL;
	this->wstrCharCode	=	L"Shift_JIS";
	this->fprequest	=	NULL;
	this->fpload	=	NULL;
	this->fpunload	=	NULL;

	return true;
}

CShiori::~CShiori()
{
	if( this->hModule )	FreeLibrary( this->hModule );
}




















