#include "CShiori.h"

#include <iostream>
#include <vector>
using namespace std;

extern BOOL WINAPI WindowEventHandler(DWORD dwCtrlType);
extern void str_split( wstring &ws, const wstring &sps, vector<wstring> &vec );
extern void str_dq_fix( vector<wstring> &vec, wstring sps=L" " );
extern void cmdShioriLoad( string strShioriFileName );
extern void cmdShioriUnLoad();
extern void cmdHelp();
extern void cmdEndAA();

CShiori	shiori( "cmd_tester" );

int main( int argc, char *argv[] )
{
	wcout << L"* cmd_shiori_tester ver 1.0 *" << endl;

	SetConsoleCtrlHandler( WindowEventHandler, TRUE);

	string	strShioriFileName;
	strShioriFileName	=	DescriptDataRead( OpenTextFile("descript.txt"), "shiori" );
	if( strShioriFileName.length() == 0 )	strShioriFileName	=	"shiori.dll";

	if( argc > 1 )	strShioriFileName	=	argv[1];

	wcout.imbue(locale("", locale::ctype));

	cmdShioriLoad( strShioriFileName );

	wcout << L"* helpƓ͂Ɛ\܂ *" << endl;
	vector<wstring>	vecCommand;
	wstring			wstrCommand;
	for(;;)
	{
		wstrCommand	=	L"";
		wcout << L">";
		getline( wcin, wstrCommand );


		str_split( wstrCommand, L" ", vecCommand );
		str_dq_fix( vecCommand );

		if( vecCommand[0] == L"load" && vecCommand.size() >= 2 )
		{
			if( shiori.isexist() )	cmdShioriUnLoad();
			strShioriFileName	=	utf16_to_sjis(vecCommand[1].c_str());
			cmdShioriLoad( strShioriFileName );
		}
		else if( vecCommand[0] == L"unload" )
		{
			if( shiori.isexist() )	cmdShioriUnLoad();
		}
		else if( vecCommand[0] == L"reload" )
		{
			if( shiori.isexist() )	cmdShioriUnLoad();
			cmdShioriLoad( strShioriFileName );
		}
		else if( vecCommand[0] == L"get" && vecCommand.size() >= 2 )
		{
			if( ! shiori.isexist() )	continue;

			wstring	wstrID	=	vecCommand[1];
			vecCommand.erase( vecCommand.begin() );
			vecCommand.erase( vecCommand.begin() );

			wstring	wstrResponse;
			wstrResponse	=	shiori.request( 1, utf16_to_sjis(wstrID.c_str()).c_str(), vecCommand );

			wcout << wstrResponse << endl; 
		}
		else if( vecCommand[0] == L"notify" && vecCommand.size() >= 2 )
		{
			if( ! shiori.isexist() )	continue;

			wstring	wstrID	=	vecCommand[1];
			vecCommand.erase( vecCommand.begin() );
			vecCommand.erase( vecCommand.begin() );

			wstring	wstrResponse;
			wstrResponse	=	shiori.request( 0, utf16_to_sjis(wstrID.c_str()).c_str(), vecCommand );
			wcout << wstrResponse << endl; 
		}
		else if( vecCommand[0]	== L"help" )
		{
			cmdHelp();
		}
		else if( vecCommand[0]	== L"exit" )
		{
			cmdEndAA();
			break;
		}

	}

	if( shiori.isexist() )	cmdShioriUnLoad();
	Sleep( 1000 );
	return 0;
}

void str_split( wstring &ws, const wstring &sps, vector<wstring> &vec )
{
	size_t	offset	=	0,
			nextsp	=	0;
	vec.clear();

	do
	{
		nextsp	=	ws.find( sps, offset );
		if( nextsp == ws.npos )	nextsp	=	ws.length();
		
		vec.push_back( ws.substr( offset, nextsp-offset ) );
		
		offset	=	nextsp + sps.length();
	}while( offset <= ws.length() );
}

void str_dq_fix( vector<wstring> &vec, wstring sps )
{
	vector<wstring>	result;
	wstring	ws;
	for( int i=0; i<vec.size(); )
	{
		ws	=	L"";
		ws	=	vec[i];
		i++;
		while( i < vec.size() )
		{
			if( (ws.at(0) == L'\"') && (ws.at(ws.length()-1)!=L'\"') )
			{
				ws += sps;
				ws += vec[i];
				i++;
			}
			else
				break;
		}

		if( (ws.at(0) == L'\"') && (ws.at(ws.length()-1)==L'\"') )
		{
			ws = ws.substr( 1, ws.length()-2 );
		}
		result.push_back( ws );
	}

	vec = result;
}

void cmdShioriLoad( string strShioriFileName )
{
	if( ! shiori.load( strShioriFileName.c_str() ) )
	{
		wcout << L"* SHIORI(";
		wcout << sjis_to_utf16(strShioriFileName.c_str());
		wcout << L")̓ǂݍ݂Ɏs܂B" << endl;
		shiori.unload();
		return ;
	}

	char	*ppFirstInfo[]	=	{ "version", "ownerghostname", "craftman", "craftmanw" };
	wstring	wstrResponse;
	wcout << wstring(L"shiori: ") + sjis_to_utf16(strShioriFileName.c_str()) << endl;
	for( int i=0; i<4; i++ )
	{
		wstrResponse	=	shiori.request( 1, ppFirstInfo[i], 0 );
		if( wstrResponse == L"204 No Content" || wstrResponse == L"400 Bad Request" )	continue;

		wcout << sjis_to_utf16(ppFirstInfo[i]) + L": " + wstrResponse << endl;
	}
	wcout << L"* SHIORIǂݍ݂܂ *" << endl;
}

void cmdShioriUnLoad()
{
	shiori.unload();
	wcout << L"* SHIORIj܂ *" << endl;
}

// EBhÊ{^NbNSHIORIj
BOOL WINAPI WindowEventHandler(DWORD dwCtrlType)
{
	BOOL ret = false;
	if(dwCtrlType == CTRL_CLOSE_EVENT) {
		shiori.unload();
		ret = true;
	}
	return ret;
}

void cmdHelp()
{
	wcout << L"* help\܂ *" << endl;
	Sleep(500);
	wcout << L"load (SHIORIt@C)\n@SHIORIǂݍ݂܂B\n@łɓǂ݂܂ĂSHIORIꍇ͔j܂B" << endl;
	wcout << L"reload\n@OɓǂݍSHIORIǂݍݒ܂B" << endl;
	wcout << L"unload\n@SHIORIj܂B" << endl;
	wcout << L"get (CxgID) (Reference0) (Reference1) ...\n@SHIORIGETNGXg𑗂܂B\n@Referenceɋ󔒂܂ޒlw肵\n@_uNH[gň͂񂾕񂪎g܂B" << endl;
	wcout << L"notify (CxgID) (Reference0) (Reference1) ...\n@SHIORINOTIFYNGXg𑗂܂B\n@Referenceɋ󔒂܂ޒlw肵\n@_uNH[gň͂񂾕񂪎g܂B" << endl;
	wcout << L"help\n@͂̕\܂B" << endl;
	wcout << L"exit\n@̃vOI܂B" << endl;
}

void cmdEndAA()
{
	wcout << L"@ Q@_ Q\n@/  j!)@S)\n@!  |/ ))r @@\n@!  |!!L|ɁR\n@!  Ɂ)K! @ R\n@  virL`l\n@@    ' l___\n" << endl;
}

