#include "util.h"


string OpenTextFile(string strFileName)
{
	char	*pBuf;
	HANDLE	hFile;
	DWORD	dwFileSize;
	DWORD	dwReadBytes;
	string	str;

	hFile = CreateFile(strFileName.c_str(),
		GENERIC_READ,
		0,
		NULL,
		OPEN_EXISTING,
		FILE_ATTRIBUTE_NORMAL,
		NULL);
	if (hFile == INVALID_HANDLE_VALUE)
		return str;

	dwFileSize = GetFileSize(hFile, NULL);
	pBuf = (char*)malloc(dwFileSize + 2);
	if (pBuf == NULL)
	{
		CloseHandle(hFile);
		return str;
	}

	ReadFile(hFile, pBuf, dwFileSize, &dwReadBytes, NULL);

	pBuf[dwFileSize] = '\0';
	str = pBuf;

	free(pBuf);
	CloseHandle(hFile);

	return str;
}

string DescriptDataRead( string &strDescript, string dataname)
{
	string::size_type	spos;
	spos = strDescript.find(dataname);
	if (spos != strDescript.npos)
	{
		string::size_type	endpos;
		if (strDescript.find("\n", spos) != strDescript.npos)
			endpos = strDescript.find("\n", spos);
		else endpos = strDescript.length();

		string LoadTarget;
		LoadTarget = strDescript.substr(spos, endpos - spos);
		LoadTarget = ReplaceAll(LoadTarget, "\r", "");
		LoadTarget = ReplaceAll(LoadTarget, "\n", "");

		if (LoadTarget.find(",") != strDescript.npos)
		{
			return LoadTarget.substr(LoadTarget.find(",") + 1, LoadTarget.length() - LoadTarget.find(",") + 1);
		}
	}

	return string("");
}

//  u
string& ReplaceAll(string &haystack, string str1, string str2)
{
	string::size_type  Pos(haystack.find(str1));

	while (Pos != string::npos)
	{
		haystack.replace(Pos, str1.length(), str2);
		Pos = haystack.find(str1,Pos+str2.length());
	}

	return haystack;
}

vector<wstring> &strsplit(wstring &ws, const wstring &sps, vector<wstring> &vecWords)
{
	size_t	offset = 0, nextsp = 0;

	do
	{
		nextsp = ws.find(sps, offset);
		if (nextsp == ws.npos)	nextsp = ws.length();

		vecWords.push_back( ws.substr(offset, nextsp - offset) );

		offset = nextsp + sps.length();
	} while (offset <= ws.length());

	return vecWords;
}

//S_JIS->UNICODEϊ
wstring	sjis_to_utf16( const char *psjis )
{
	wstring		wstrunicode;
	DWORD		dwConvSize	= 0;
	wchar_t		*pwConvBuf	= NULL;

	try
	{
		//sjisUnicodeɂ̂ɕKvȃTCY𒲂ׂ
		dwConvSize	=	MultiByteToWideChar( CP_ACP, 0, psjis, -1, NULL, 0 );
		if( dwConvSize == 0 )	throw 0;
		//dwConvSizeɕKvȗ̈擾
		pwConvBuf	=	new	wchar_t[dwConvSize+2];
		if( pwConvBuf == NULL )	throw 1;

		//sjisUnicodeɕϊ
		dwConvSize	=	MultiByteToWideChar( CP_ACP, 0, psjis, -1, pwConvBuf, dwConvSize );
		if( dwConvSize == 0 )	throw 1;
		pwConvBuf[dwConvSize]	=	0;

		//ϊUNICODE̕strsjisɓ
		wstrunicode	=	pwConvBuf;

		//ǧn
		delete[]	pwConvBuf;
	}
	catch( ... )
	{
		if( pwConvBuf )	delete[]	pwConvBuf;
	}
	
	return		wstrunicode;
}
//unicode->sjisϊ
string	utf16_to_sjis( const wchar_t *punicode )
{
	string		strsjis;
	DWORD		dwConvSize	= 0;
	char		*pConvBuf	= NULL;
	
	try
	{
		//UTF-16S-JISɕϊ̂ɕKvȃTCY𒲂ׂ
		dwConvSize	=	WideCharToMultiByte( CP_ACP, 0, punicode, -1, NULL, 0, NULL, NULL );
		if( dwConvSize == 0 )	throw 1;

		//dwConvSizeɕKvȗ̈擾
		pConvBuf	=	new	char[dwConvSize+1];
		if( dwConvSize == 0 )	throw 2;

		//UTF-16S-JISɕϊ
		dwConvSize	=	WideCharToMultiByte( CP_ACP, 0, punicode, -1, pConvBuf, dwConvSize, "-", NULL );
		if( dwConvSize == 0 )	throw 2;

		//ϊS-JIS̕strsjisɓ
		strsjis	=	pConvBuf;

		//ǧn
		delete[]	pConvBuf;
	}
	catch( ... )
	{
		if( pConvBuf )	delete[]	pConvBuf;
	}
	
	return		strsjis;
}
//UTF8->sjisϊ
string	utf8_to_sjis( const char *putf )
{
	
	string		strsjis;
	DWORD		dwConvSize	= 0;
	wchar_t		*pwConvBuf	= NULL;
	char		*pConvBuf	= NULL;
	
	try
	{
		//UTF-8UTF-16ɂ̂ɕKvȃTCY𒲂ׂ
		dwConvSize	=	MultiByteToWideChar( CP_UTF8, 0, putf, -1, NULL, 0 );
		if( dwConvSize == 0 )	throw 0;
		
		//dwConvSizeɕKvȗ̈擾
		pwConvBuf	=	new	wchar_t[dwConvSize+2];
		if( pwConvBuf == NULL )	throw 1;

		//UTF-8UTF-16ɕϊ
		dwConvSize	=	MultiByteToWideChar( CP_UTF8, 0, putf, -1, pwConvBuf, dwConvSize );
		if( dwConvSize == 0 )	throw 1;
		pwConvBuf[dwConvSize]	=	0;

		//UTF-16S-JISɕϊ̂ɕKvȃTCY𒲂ׂ
		dwConvSize	=	WideCharToMultiByte( CP_ACP, 0, pwConvBuf, -1, NULL, 0, NULL, NULL );
		if( dwConvSize == 0 )	throw 1;

		//dwConvSizeɕKvȗ̈擾
		pConvBuf	=	new	char[dwConvSize+1];
		if( dwConvSize == 0 )	throw 2;

		//UTF-16S-JISɕϊ
		dwConvSize	=	WideCharToMultiByte( CP_ACP, 0, pwConvBuf, -1, pConvBuf, dwConvSize, "-", NULL );
		if( dwConvSize == 0 )	throw 2;

		//ϊS-JIS̕strsjisɓ
		strsjis	=	pConvBuf;

		//ǧn
		delete[]	pwConvBuf;
		delete[]	pConvBuf;
	}
	catch( ... )
	{
		if( pwConvBuf )	delete[]	pwConvBuf;
		if( pConvBuf )	delete[]	pConvBuf;
	}
	
	return		strsjis;
}
// utf-8->unicode
wstring	utf8_to_utf16( const char *putf )
{
	wstring		wstrRet;
	DWORD		dwConvSize	= 0;
	wchar_t		*pwConvBuf	= NULL;
	
	try
	{
		//UTF-8UTF-16ɂ̂ɕKvȃTCY𒲂ׂ
		dwConvSize	=	MultiByteToWideChar( CP_UTF8, 0, putf, -1, NULL, 0 );
		if( dwConvSize == 0 )	throw 0;
		
		//dwConvSizeɕKvȗ̈擾
		pwConvBuf	=	new	wchar_t[dwConvSize+2];
		if( pwConvBuf == NULL )	throw 1;

		//UTF-8UTF-16ɕϊ
		dwConvSize	=	MultiByteToWideChar( CP_UTF8, 0, putf, -1, pwConvBuf, dwConvSize );
		if( dwConvSize == 0 )	throw 1;
		pwConvBuf[dwConvSize]	=	0;

		wstrRet	=	pwConvBuf;

		//ǧn
		delete[]	pwConvBuf;
	}
	catch( ... )
	{
		if( pwConvBuf )	delete[]	pwConvBuf;
	}
	
	return		wstrRet;
}
// unicode->utf-8
string	utf16_to_utf8( const wchar_t *pws )
{
	string		strRet;
	DWORD		dwConvSize	= 0;
	char		*pwConvBuf	= NULL;
	
	try
	{
		//UTF-16UTF-8ɂ̂ɕKvȃTCY𒲂ׂ
		dwConvSize	=	WideCharToMultiByte( CP_UTF8, 0, (LPCWSTR)pws, -1, NULL, 0, NULL, NULL );
		if( dwConvSize == 0 )	throw 0;
		
		//dwConvSizeɕKvȗ̈擾
		pwConvBuf	=	new	char[dwConvSize+2];
		if( pwConvBuf == NULL )	throw 1;

		//UTF-8UTF-16ɕϊ
		dwConvSize	=	WideCharToMultiByte( CP_UTF8, 0, (LPCWSTR)pws, -1, (LPSTR)pwConvBuf, dwConvSize, NULL, NULL );
		if( dwConvSize == 0 )	throw 1;
		pwConvBuf[dwConvSize]	=	0;

		strRet	=	pwConvBuf;

		//ǧn
		delete[]	pwConvBuf;
	}
	catch( ... )
	{
		if( pwConvBuf )	delete[]	pwConvBuf;
	}
	
	return		strRet;
}

